/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>

#include <cstrike>

#include <fun>

#include <engine>

#define PLUGIN	"MR15"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

const maxPlayers = 33;

enum stateGame {
	FIRST_GAME ,
	TEAM_CHANGE,
	SECOND_GAME
}

new stateGame: currentState = FIRST_GAME;

new pCvarRounds;

new bool: bFirstRound = true;

new iCurrentRound = 0;

new iScoreCTAll = 0,
	iScoreTTAll = 0;
	
new iScoreCT = 0 ,
	iScoreTT = 0;
	
new soundOnStart[] = "sound/lets_get_ready.mp3" ;
new soundSecondRound[] = "sound/round_two.mp3";
new soundVictory[] = "sound/jedziesz.mp3"

public plugin_init(){
	
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	pCvarRounds	=	register_cvar( "mr_rounds" , "2" );
	
	register_event("HLTV", "NewRound", "a", "1=0", "2=0");
	register_logevent("RoundBegin", 2, "1=Round_Start");
	
	register_event( "TeamScore", "teamScore", "a");
	
	register_event( "TextMsg", "eventRestart", "a", "2&#Game_will_restart_in" );
	
	register_clcmd( "say timeleft" , "printTimeLeft" );
	register_clcmd( "say /timeleft" , "printTimeLeft" );
	
	register_clcmd( "say /wynik" , "printScore" );
}

public plugin_precache(){
	precache_generic( soundOnStart );
	precache_generic( soundSecondRound );
	precache_generic( soundVictory );
}

public eventRestart(){
	iCurrentRound = 0;
	
	iScoreCT = 0;
	iScoreTT = 0;
}

public printScore( id ){
	client_print( id , print_chat , "Obecny wynik TT %d | CT %d" , iScoreTTAll , iScoreCTAll );
}

public printTimeLeft(){
	client_print( 0 , print_chat , "Do konca mapy pozostalo : %d rund" , ( 2 * get_pcvar_num( pCvarRounds ) ) - ( iScoreCTAll + iScoreTTAll ) );
}

public teamScore(){
	new team[2]
	
	read_data( 1 , team , charsmax( team ) );
	
	if ( team[0]=='C'){
		iScoreCTAll += ( read_data( 2 ) - iScoreCT );
		iScoreCT = read_data( 2 );
	}
	else if ( team[0]=='T'){
		iScoreTTAll += ( read_data( 2 ) - iScoreTT );
		iScoreTT = read_data( 2 );
	}
}

public RoundBegin(){
	iCurrentRound++;
	
	new cvarRoundsValue = get_pcvar_num( pCvarRounds );
	
	if( currentState == FIRST_GAME ){
		if( cvarRoundsValue == iCurrentRound ){
			
			set_hudmessage( 255, 255, 255, -1.0, 0.27, 0, 6.0, 5.0 );
			show_hudmessage( 0, "PO TEJ RUNDZIE ZMIANA DRUZYN!");
			
		}
		else if( cvarRoundsValue + 1 == iCurrentRound  ){
			currentState = TEAM_CHANGE;
			
			set_hudmessage( 255, 255, 255, -1.0, 0.27, 0, 6.0, 5.0 );
			show_hudmessage( 0, "CZAS NA DRUGA POLOWE");
			
			client_print( 0 , print_chat , "Zaczynamy po 3 restartach" );
			
			playMp3( 0 , soundSecondRound );
			
			set_task( 10.0 , "changeTeams" );
		}
	}
	else if( currentState == SECOND_GAME ){
		
		if( matchEnd() ){
			new szText[ 256 ];
		
			if( iScoreCTAll > iScoreTTAll ){
				copy( szText , charsmax( szText ) , "ANTY-TERRORYSCI WYGRALI MECZ!" );
				
				playMp3( 0 , soundVictory );
			}
			else if( iScoreTTAll > iScoreCTAll ){
				copy( szText , charsmax( szText ) , "TERRORYSCI WYGRALI MECZ!" );
				
				playMp3( 0 , soundVictory );
			}
			else{
				copy( szText , charsmax( szText ) , "REMIS" );
			}
			
			set_hudmessage( 255, 255, 255, -1.0, 0.27, 0, 6.0, 5.0 );
			show_hudmessage( 0, szText );
			
			set_task( 10.0 , "mapChange" );
		}
		
	}
}

public NewRound(){
	
	client_print( 0 , print_chat , "Obecny wynik TT %d | CT %d" , iScoreTTAll , iScoreCTAll );
	
	if( !bFirstRound ){
		return ;
	}
	
	bFirstRound = false;
	
	playMp3( 0 , soundOnStart );
	
	make3rr();
}

public client_PreThink( id ){
	if( !is_user_alive( id ) || currentState != TEAM_CHANGE ){
		return PLUGIN_CONTINUE;
	}
	
	set_user_maxspeed( id , 0.01 );
	
	return PLUGIN_CONTINUE;
}

public changeTeams(){
	new CsInternalModel:listModelsCT[ 4 ] = {
		CS_CT_URBAN ,
		CS_CT_GSG9 ,
		CS_CT_GIGN ,
		CS_CT_SAS
	}
	
	new CsInternalModel:listModelsTT[ 4 ] = {
		CS_T_TERROR,
		CS_T_LEET ,
		CS_T_ARCTIC,
		CS_T_GUERILLA,
	}
	
	new listPlayersCT[ maxPlayers ];
	new currentElement = 0;
	
	new tmpValue = iScoreCTAll;
	
	iScoreCTAll = iScoreTTAll;
	iScoreTTAll = tmpValue;
	
	iScoreCT = 0;
	iScoreTT = 0;
	
	for( new iCurrentPlayer = 1 ; iCurrentPlayer < maxPlayers ; iCurrentPlayer++ ){
		
		if( !is_user_connected( iCurrentPlayer ) ) {
			continue;
		}
		
		switch( cs_get_user_team( iCurrentPlayer ) ){
			case CS_TEAM_CT : {
				listPlayersCT[ currentElement++ ] = iCurrentPlayer;
			}
			case CS_TEAM_T : {
				cs_set_user_team( iCurrentPlayer , CS_TEAM_CT , listModelsCT[ random( sizeof listModelsCT ) ] );
			}
		}
	}
	
	for( new iCurrentElement = 0 ; iCurrentElement < currentElement ; iCurrentElement++ ){
		
		if( !is_user_connected( listPlayersCT[ iCurrentElement ] ) ){
			continue;
		}
		
		cs_set_user_team( listPlayersCT[ iCurrentElement ] , CS_TEAM_T , listModelsTT[ random( sizeof listModelsTT ) ] );
		
	}
	
	
	currentState = SECOND_GAME;
	
	make3rr();
}

public mapChange(){
	server_cmd( "mp_timelimit 0" );
	server_exec();
	
	server_cmd( "mp_winlimit %d" , max( 1 , min( iScoreCT , iScoreTT ) ) );
	server_exec();
	
	new iRet = 0,
		gHandleForward = CreateMultiForward( "voteNextmap" , ET_IGNORE );
		
	if( gHandleForward ){
		ExecuteForward( gHandleForward , iRet );
	}
}

make3rr(){
	makeRestart( 1 );
	
	set_task( 1.5 , "makeSecondRestart" , 1 );
	set_task( 3.5 , "makeThirdRestart" , 2 );
}

public makeSecondRestart(){
	makeRestart( 1 );
}

public makeThirdRestart(){
	makeRestart( 1 );
}

makeRestart( iTime = 1 ){
	server_cmd( "sv_restart %d" , iTime );
}

bool:matchEnd(){
	new iDiffrenceCT = get_pcvar_num( pCvarRounds ) - iScoreCTAll;
	new iDiffrenceTT = get_pcvar_num( pCvarRounds ) - iScoreTTAll;
	
	if( iScoreCTAll > iScoreTTAll + iDiffrenceTT || iDiffrenceCT < 0 ){
		return true;
	}
	
	if( iScoreTTAll > iScoreCTAll + iDiffrenceCT || iDiffrenceTT < 0 ){
		return true;
	}
	
	if( iDiffrenceCT == 0 && iDiffrenceTT == 0 ){
		return true;
	}
	
	return false;
}

playMp3( id , sound[] ){
	client_cmd( id , "mp3 play ^"%s^"", sound );
}
