#include <amxmodx>
#include <amxmisc>
#include <sqlx>

#define PLUGIN "New Plug-In"
#define VERSION "1.0"
#define AUTHOR "DarkGL"

#define MAX 32
#define TABLE_NAME "ranking_zm"

forward zombieHeal( id );
forward zombieKilled( id );
forward humanInfect( id );

enum eSqlCvars{
	eSqlHost,
	eSqlUser,
	eSqlPass,
	eSqlDb
}

new pCvarSql[eSqlCvars],pCvarSaveType;

new Handle:sqlTuple;

new bool:bSql = false;

enum ePlayerInf{
	szPlayerName[64],
	zombiesKill,
	zombiesHeal,
	humanKill,
	frags,
	points,
	bool:bSqlPlayer,
	bestKill,
	bestHeal,
	bestHuman,
	bestFrags
}

new playerInf[MAX+1][ePlayerInf];

new iAmountPlayersInSql;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	pCvarSql[eSqlHost]	=	register_cvar("sql_host_zombie"	,"localhost");
	pCvarSql[eSqlUser]	=	register_cvar("sql_user_zombie"	,"user");
	pCvarSql[eSqlPass]	=	register_cvar("sql_pass_zombie"	,"pass");
	pCvarSql[eSqlDb]	=	register_cvar("sql_db_zombie"	,"db");
	
	//1 - nick 2 - steam id 3 - ip 4 - nick i steamid
	pCvarSaveType		=	get_pcvar_num(	register_cvar( "medale_save_type" , "1" ) )
	
	set_task(0.5,"MsgIntermission",.flags = "d");
	
	register_clcmd( "say /top" , "topFunc" );
	register_clcmd( "say /rank" , "rankFunc" );
	
	register_event("DeathMsg", "DeathMsg", "a")
}


public plugin_cfg(){
	new szHost[64],szUser[64],szPass[64],szDb[64];
	
	get_pcvar_string(pCvarSql[eSqlHost],szHost	,	charsmax( szHost ) );
	get_pcvar_string(pCvarSql[eSqlUser],szUser	,	charsmax( szUser ) );
	get_pcvar_string(pCvarSql[eSqlPass],szPass	,	charsmax( szPass ) );
	get_pcvar_string(pCvarSql[eSqlDb],	szDb	,	charsmax( szDb ) );
	
	sqlTuple = SQL_MakeDbTuple(szHost,szUser,szPass,szDb);
	
	bSql	=	false;
	
	new szTmp[256];
	
	formatex(szTmp,charsmax( szTmp ),"CREATE TABLE IF NOT EXISTS %s ( steamid VARCHAR(40) , nick VARCHAR(40) , ip VARCHAR(40) , points INT NOT NULL DEFAULT  '0' , bestkill INT NOT NULL DEFAULT  '0' , bestheal INT NOT NULL DEFAULT  '0' , besthuman INT NOT NULL DEFAULT  '0' , bestfrags INT NOT NULL DEFAULT  '0' )",TABLE_NAME);
	
	SQL_ThreadQuery(sqlTuple,"sqlStartHandle",szTmp);
	
}

public sqlStartHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle: Error on sqlStartHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle:  sqlStartHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	bSql	=	true;
	
	new szText[ 256 ];
	
	formatex( szText , charsmax( szText ) , "SELECT COUNT(*) FROM `%s`" , TABLE_NAME );
	
	SQL_ThreadQuery( sqlTuple , "sqlAmount" , szText  );
	
	return PLUGIN_CONTINUE
}

public sqlAmount( FailState,Handle:Query,Error[],Errcode,Data[],DataSize){
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle: Error on sqlStartHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlStartHandle:  sqlStartHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	iAmountPlayersInSql = SQL_ReadResult( Query, 0 );
	
	return PLUGIN_CONTINUE
}

public plugin_end(){
	SQL_FreeHandle(sqlTuple);
}

public client_authorized(id){
	copy(playerInf[id][szPlayerName],63,"")
	
	playerInf[id][zombiesKill]		=	0;
	playerInf[id][zombiesHeal]		=	0;
	playerInf[id][humanKill]		=	0;
	playerInf[id][frags]			=	0;
	playerInf[id][points]			=	0;
	playerInf[id][bestKill]			=	0;
	playerInf[id][bestHeal]			=	0;
	playerInf[id][bestHuman]		=	0;
	playerInf[id][bestHuman]		=	0;

	playerInf[id][bSqlPlayer]	=	false;
	
	get_user_name(id,playerInf[id][szPlayerName], 63 );
	
	replace_all(playerInf[id][szPlayerName], 63 ,"'","_")
	replace_all(playerInf[id][szPlayerName], 63 ,"`","_")
	
	if(!is_user_bot(id) && !is_user_hltv(id))	sqlLoadPlayer(id);
	
}

public client_disconnect(id){
	
	if(playerInf[id][bSqlPlayer])	saveSqlPlayer(id);
	
	copy(playerInf[id][szPlayerName],63,"")
	
	playerInf[id][zombiesKill]		=	0;
	playerInf[id][zombiesHeal]		=	0;
	playerInf[id][humanKill]		=	0;
	playerInf[id][frags]			=	0;
	playerInf[id][points]			=	0;
	playerInf[id][bestKill]			=	0;
	playerInf[id][bestHeal]			=	0;
	playerInf[id][bestHuman]		=	0;
	playerInf[id][bestHuman]		=	0;

	
	playerInf[id][bSqlPlayer]	=	false;
}

public saveSqlPlayer(id){
	if(!bSql || !playerInf[id][bSqlPlayer])	return ;
	
	new szTmp[512],iLen = 0,szTmp2[128],szAuth[64],szIp[64];
	
	get_user_authid(id ,szAuth,charsmax ( szAuth ) )
	get_user_ip(id, szIp , charsmax ( szIp )) 
	
	iLen += formatex(szTmp , charsmax( szTmp ) , "UPDATE %s SET steamid = '%s' , nick = '%s' , ip = '%s' , points = '%d' ,bestkill = '%d' , bestheal = '%d' , " , TABLE_NAME, szAuth , playerInf[id][szPlayerName] , szIp  , playerInf[id][zombiesKill] , playerInf[id][zombiesHeal] , playerInf[id][ humanKill ] , playerInf[id][ frags ] , playerInf[id][ points ] , playerInf[id][ bestKill ] , playerInf[id][ bestHeal ] );
	iLen += formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "besthuman = '%d' , bestfrags = '%d' WHERE " , playerInf[id][ bestHuman ] , playerInf[id][ bestFrags ] );
	
	switch(pCvarSaveType){
		case 1:{
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "nick = '%s'",playerInf[id][szPlayerName] )
		}
		case 2:{
			get_user_authid( id, szTmp2 , charsmax ( szTmp2 ) );
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "steamid = '%s'",szTmp2 )
		}
		case 3:{
			get_user_ip( id, szTmp2 , charsmax ( szTmp2 ) );
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "ip = '%s'",szTmp2 )
		}
		case 4:{
			get_user_authid( id, szTmp2 , charsmax ( szTmp2 ) );
			
			if(is_steam( szTmp2 ))
				formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "steamid = '%s'",szTmp2 )
			else
				formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "nick = '%s'",playerInf[id][szPlayerName] )
		}
	}
	
	SQL_ThreadQuery(sqlTuple,"sqlSaveHandle",szTmp);
}

public sqlSaveHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlSaveHandle: Error on sqlSaveHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlSaveHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlSaveHandle:  sqlSaveHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_CONTINUE
}

public sqlLoadPlayer(id){
	if(!bSql)	return ;
	
	new szTmp[512],iLen = 0,szTmp2[128];
	
	iLen += formatex(szTmp , charsmax( szTmp ) , "SELECT * FROM %s WHERE ",TABLE_NAME);
	
	switch(pCvarSaveType){
		case 1:{
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen, "nick = '%s'",playerInf[id][szPlayerName] )
		}
		case 2:{
			get_user_authid( id, szTmp2 , charsmax ( szTmp2 ) );
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen, "steamid = '%s'",szTmp2 )
		}
		case 3:{
			get_user_ip( id, szTmp2 , charsmax ( szTmp2 ) );
			formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen, "ip = '%s'",szTmp2 )
		}
		case 4:{
			get_user_authid( id, szTmp2 , charsmax ( szTmp2 ) );
			
			if(is_steam( szTmp2 ))
				formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen, "steamid = '%s'",szTmp2 )
			else
				formatex(szTmp[ iLen ] , charsmax( szTmp ) - iLen , "nick = '%s'",playerInf[id][szPlayerName] )
		}
	}
	
	new iData[1];
	iData[0] = id;
	
	SQL_ThreadQuery(sqlTuple,"sqlLoadHandle",szTmp,iData,1);
}

public sqlLoadHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlLoadHandle: Error on sqlStartHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlLoadHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","sqlLoadHandle:  sqlStartHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	new id = Data[0]
	
	playerInf[id][bSqlPlayer] = true;
	
	if(SQL_MoreResults(Query)){
		
		playerInf[id][points] 	= 	SQL_ReadResult(Query,SQL_FieldNameToNum(Query,"points"));
		
	}
	else{
		new szAuth[64],szIp[64],szTmp[256]
		
		get_user_authid(id , szAuth , charsmax ( szAuth ) );
		get_user_ip(id, szIp, charsmax ( szIp ) )
		
		formatex(szTmp,charsmax( szTmp ),"INSERT INTO %s VALUES ( '%s' , '%s' , '%s' , 0 , 0 , 0 , 0 , 0 )",TABLE_NAME , szAuth , playerInf[id][szPlayerName] , szIp);
		
		SQL_ThreadQuery(sqlTuple,"ignoreHandle",szTmp);
	}
	
	return PLUGIN_CONTINUE
}

public ignoreHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","ignoreHandle: Error on ignoreHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","ignoreHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","ignoreHandle: ignoreHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_CONTINUE
}

public MsgIntermission() {
	
	new iBestFrager	=	0,
		iBestKillZombie	=	0,
		iBestHumanKill	=	0,
		iBestZombieHeal	=	0;
	
	for(new i = 1; i < MAX + 1;i++){
		if(!is_user_connected(i) || !playerInf[i][bSqlPlayer] || is_user_bot(i) || is_user_hltv(i))	continue;
		
		playerInf[ i ][ frags ]	=	get_user_frags( i );
		
		if( playerInf[ i ][ frags ] > playerInf[ iBestFrager ][ frags ] ){
			iBestFrager	=	i;
		}
		if( playerInf[ i ][ zombiesKill ] > playerInf[ iBestKillZombie ][ zombiesKill ] ){
			iBestKillZombie	=	i;
		}
		if( playerInf[ i ][ humanKill ] > playerInf[ iBestHumanKill ][ humanKill ] ){
			iBestHumanKill	=	i;
		}
		if( playerInf[ i ][ zombiesHeal ] > playerInf[ iBestZombieHeal ][ zombiesHeal ] ){
			iBestZombieHeal	=	i;
		}
	}
	
	playerInf[ iBestFrager ][ points ]		+=	5;
	playerInf[ iBestKillZombie ][ points ]	+=	3;
	playerInf[ iBestHumanKill ][ points ]	+=	2;
	playerInf[ iBestZombieHeal ][ points ]	+=	1;
	
	playerInf[ iBestFrager ][ bestFrags ]		+=	1;
	playerInf[ iBestKillZombie ][ bestKill ]	+=	1;
	playerInf[ iBestHumanKill ][ bestHuman ]	+=	1;
	playerInf[ iBestZombieHeal ][ bestHeal ]	+=	1;
	
	new szNameFrager[ 64 ],
		szNameKill[ 64 ],
		szNameHuman[ 64 ],
		szNameZombie[ 64 ];
	
	
	get_user_name( iBestFrager , szNameFrager , charsmax( szNameFrager ) );
	get_user_name( iBestKillZombie  , szNameKill , charsmax( szNameKill ) );
	get_user_name( iBestHumanKill , szNameHuman , charsmax( szNameHuman ) );
	get_user_name( iBestZombieHeal , szNameZombie , charsmax( szNameZombie ) );
	
	new szText[ 1024 ] ,
		iLen	=	0;
	
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "<body bgcolor = 'black'><center><font color = 'white'>" );
	
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "%s : najwiecej fragow + 5pkt<br />" , iBestFrager );
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "%s : najwiecej zabitych zombie +3pkt<br />" , iBestKillZombie );
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "%s : najwiecej zaraonych ludzi +2pkt<br />" , iBestHumanKill );
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "%s : najwiecej uleczonych zombie +1pkt<br />" , iBestZombieHeal );
	
	iLen	+=	formatex( szText[ iLen ] , charsmax( szText) - iLen , "</font></center></body>" );
	
	show_motd( 0 , szText , "Zombie Rank" );
}

stock bool:is_steam(auth[]) {
	if(contain(auth, "STEAM_0:0:") != -1 || contain(auth, "STEAM_0:1:") != -1)
		return true;
	
	return false;
}

public topFunc(id){
	if(!bSql)	return PLUGIN_HANDLED;
	
	new szTmp[256];
	
	formatex(szTmp,charsmax( szTmp ),"SELECT * FROM %s ORDER BY points DESC LIMIT 15",TABLE_NAME);
	
	new iData[1];
	iData[0]	=	id;
	
	SQL_ThreadQuery(sqlTuple,"createRankHandle",szTmp,iData,1);
	
	return PLUGIN_HANDLED;
}

public createRankHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle: Error on createRankHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle:  sqlStartHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	if(SQL_MoreResults(Query)){
		new szText[2048],iLen = 0,iPos = 1;
		
		iLen += formatex( szText, charsmax( szText ),"<body bgcolor=#000000><font color=#FFB000 size = ^"4^"><pre>%2s %-22.22s %6s %8s %8s %5s^n","#","Nick","Zloto","Srebro","Braz","Suma")
		
		while(SQL_MoreResults(Query)){
			
			new szNick[64];
			
			SQL_ReadResult(Query,SQL_FieldNameToNum(Query,"nick"),szNick,charsmax ( szNick ) );
			
			replace_all(szNick, charsmax( szNick ), "<", "[")
			replace_all(szNick, charsmax(szNick ), ">", "]")
			
			iLen += formatex( szText[iLen] , charsmax( szText ) - iLen,"%2d %-22.22s %6d^n", iPos++, szNick, SQL_ReadResult(Query,SQL_FieldNameToNum(Query,"points")) );
			
			SQL_NextRow(Query);
		}
		
		show_motd(Data[0], szText, "TOP15 Rank Zm");
	}
	
	return PLUGIN_HANDLED;
}

public rankFunc( id ){
	
	if( !bSql )	return PLUGIN_HANDLED;
	
	new szTmp[256];
	
	formatex(szTmp,charsmax( szTmp ),"SELECT COUNT(*) FROM %s WHERE `points` >= %d ",TABLE_NAME , playerInf[ id ][ points ] );
	
	new iData[1];
	iData[0]	=	id;
	
	SQL_ThreadQuery(sqlTuple,"topRankHandle",szTmp,iData,1);
	
	return PLUGIN_HANDLED;
	
}

public topRankHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(Errcode)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle: Error on createRankHandle query: %s",Error)
	}
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle: Could not connect to SQL database.")
		return PLUGIN_CONTINUE
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_to_file("addons/amxmodx/logs/sql.log","createRankHandle:  sqlStartHandle Query failed.")
		return PLUGIN_CONTINUE
	}
	
	new id	=	Data[ 0 ];
	
	if( !SQL_MoreResults( Query ) || !is_user_connected( id ) ){
		
		return PLUGIN_CONTINUE;
		
	}
	
	client_print( id , 3 , "Zajmujesz %i/%i miejsce z %i punktami" , max( 1 , SQL_ReadResult( Query , 0 ) ) , iAmountPlayersInSql , playerInf[ id ][ points ] ); 
	
	return PLUGIN_CONTINUE;
}

public zombieKilled( id ){
	playerInf[ id ][ zombiesKill ]++;
}

public zombieHeal( id ){
	playerInf[ id ][ zombiesHeal ]++;
}

public humanInfect( id ){
	playerInf[ id ][ humanKill ]++;
}
